From 5a2ba8a9c6b2686aa94a8d5ac35beddf38cba24a Mon Sep 17 00:00:00 2001
From: Camelia Groza <camelia.groza@nxp.com>
Date: Mon, 4 Sep 2017 13:46:00 +0300
Subject: [PATCH] sdk_dpaa: ls1043a errata: realign skb in place if needed

Signed-off-by: Camelia Groza <camelia.groza@nxp.com>
---
 drivers/net/ethernet/freescale/sdk_dpaa/dpaa_eth_sg.c | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

--- a/drivers/net/ethernet/freescale/sdk_dpaa/dpaa_eth_sg.c
+++ b/drivers/net/ethernet/freescale/sdk_dpaa/dpaa_eth_sg.c
@@ -1024,7 +1024,6 @@ int __hot dpa_tx_extended(struct sk_buff
 #endif /* CONFIG_FSL_DPAA_TS */
 
 #ifndef CONFIG_PPC
-realign_4k:
 	if (unlikely(dpaa_errata_a010022) && a010022_check_skb(skb)) {
 		skb = a010022_realign_skb(skb);
 		if (!skb)
@@ -1073,8 +1072,11 @@ realign_4k:
 			skb = nskb;
 #ifndef CONFIG_PPC
 			if (unlikely(dpaa_errata_a010022) &&
-			    a010022_check_skb(skb))
-				goto realign_4k;
+			    a010022_check_skb(skb)) {
+				skb = realign_skb(skb);
+				if (!skb)
+					goto skb_to_fd_failed;
+			}
 #endif
 			/* skb_copy() has now linearized the skbuff. */
 		} else if (unlikely(nonlinear)) {
